//#define EBATWO
//#define ADDON2
using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Cotyounoyume
{
    public class WorldUI
    {
		#region Define vars
		public Atom UIAtom;
		public EBATCore core;
		public CustomUI customUi;
		
        MVRScript plugin;
		public WorldUIAddon1 worldUIAddon1;
		
#if	(ADDON2)	
		public WorldUIAddon2 worldUIAddon2;
#endif
		

        public Canvas canvas;
		public Vector3 canvasPos;
		public Quaternion canvasRot;
		public UIDynamicButton uiMinimizeMenu;
		public UIDynamicButton uiPauseMenu;
		public UIDynamicButton uiCloseMenu;
		public UIDynamicButton uiOpenAtomMenu;
		public UIDynamicButton uiCloseUI;
		public UIDynamicButton uiLookFrontUI;
		public UIDynamicButton uiReloadPlugins;
		public UIDynamicButton uiChangeSize;
		public UIDynamicButton uiCollapseUI;
		public UIDynamicButton uiExpandAllUI;
		public UIDynamicButton uiCollapseWOBarUI;
		public UIDynamicTextField uiStatusField;

		public UIDynamicButton uiOrgasmButton;
		public UIDynamicButton uiPeeButton;
		public UIDynamicButton uiResetExpressionButton;
		public UIDynamicButton uiCalmDownButton;
		public UIDynamicButton uiFaceForward;
		public UIDynamicButton uiFaceSideways;
		public UIDynamicButton uiFaceSidewaysAlt;
		public UIDynamicButton uiFaceSidewaysMax;
		public UIDynamicButton uiLookGlancing;
		public UIDynamicButton uiBackBending;
		public UIDynamicButton uiBackBendingStrong;
		
		public UIDynamicButton uiSoundOnButton;
		public UIDynamicButton uiEyesControlOnButton;
		public UIDynamicButton uiTearsOnButton;
		public UIDynamicButton uiExpressionOnButton;
		public UIDynamicButton uiBlushingOnButton;

		public UIDynamicButton uiDroolOnButton;			
		public UIDynamicButton uiEyesRollupOnButton;		
		public UIDynamicButton uiNippleErectionOnButton;	
		public UIDynamicButton uiClitorisErectionOnButton;
		public UIDynamicButton uiHeadMotionOnButton;
		public UIDynamicButton uiPeeingOnButton;			
		                       								
		public UIDynamicButton uiAutoExpressionOnButton;	
		public UIDynamicButton uiAutoBlinkOnButton;		
		
		public UIDynamicSlider uiStrengthSlider;
		public UIDynamicSlider uiWaveSlider;
		public UIDynamicSlider uiGaugeSlider;
		public UIDynamicSlider uiPitchSlider;
		
		public UIDynamicButton uiExpandUI     ;
		public UIDynamicButton uiExpandAction ;
		public UIDynamicButton uiExpandConfig ;
		public UIDynamicButton uiExpandSlider1;
		public UIDynamicButton uiExpandSlider2;
		public UIDynamicButton uiExpandSwitch;
		public UIDynamicButton uiExpandAddon  ;
		public UIDynamicButton uiExpandTest   ;
		public UIDynamic uiCorner     ;

		public float spacerSizeX = 1000f;
		public float spacerSizeY = 600f;
		public float buttonSizeX = 200f;
		public float buttonSizeY = 40f;
		public float toggleSizeX = 200f;
		public float toggleSizeY = 40f;
		public float sliderSizeX = 400f;
		public float sliderSizeY  =  80f;
		public float sliderSizeY2 = 180f;
		public float sliderSizeY3 = 280f;
		public float buttonSizeY3 = 140f;
		public float buttonSizeY2 = 90f;
		public float headerX = 50f;
		public float buttonSizeMinimizeX = 10f;
		public float buttonSizeX3 = 800f;
		public int fontSize = 26;
		
		private float xSpacing = 0.3f;
		private float xIndent = 0.15f;
		private float ySpacing = -0.05f;
		private float xOffsetMinimize = 0.08f;
		private float xOffset = 0.04f;
		private float yOffset = -0.08f;
        private float UIScale;
		private float smallRatio = 0.75f;
		private float smallRatioForSize = 0.80f;
		private float quick1 = 1.75f;
		private float quick2 = 2.35f;
		private float quick3 = 2.95f;
		private float quick4 = 3.55f;
		
		public int fontSizeAlt = 20;

		/*
		private float xSpacingAlt = 0.20f;
		private float xIndentAlt = 0.1f;
		private float ySpacingAlt = -0.04f;
		private float xOffsetAlt = 0.03f;
		private float yOffsetAlt = -0.06f;
		*/

		public bool isSmall = false;
		
		public string strMinimizeMenu = "❏";
		public string strMinimizeMenuAlt = "❏";
		public string strPauseMenu = "Suspend";
		public string strPauseMenuAlt = "Resume";
		public string strPauseMenuVar = "";
		public string strOpenAtomMenu = "Open Atom UI";
		public string strCloseUI = "Close UI";
		public string strChangeSize = "UI Size Small";
		public string strChangeSizeAlt = "UI Size Large";
		public string strLookFrontUI = "Look Front";
		public string strReloadPlugins = "Reload Plugins";
		public string strCollapseUI = "Collapse UI";
		public string strExpandAllUI = "Expand UI";
		public string strCollapseWOBarUI = "❤Bar Only";
		public string strStatusField = "The status of the Person is displayed here.";

		public string strOrgasmButton    = "Make Her Orgasm";
		public string strOrgasmButtonAlt = "Stop Her Orgasm";
		public string strOrgasmButtonVar = "";
		public string strMaximinzeEcstasy = "Maximize Ecstasy";
		
		public string strPeeButton    = "Make Her Squirt";
		public string strCalmDownButton    = "Calm Her Down";
		public string strResetExpressionButton    = "Reset Expression";
		public string strFaceForward = "Face Forward";
		public string strFaceSideways = "Face Sideways";
		public string strFaceSidewaysAlt = "Face Sideways Alt";
		public string strFaceSidewaysMax = "Face Sideways Max";
		public string strLookGlancing = "Look Glancing";
		public string strBackBending  = "Back Bending1";
		public string strBackBendingStrong  = "Back Bending2";
		
		public string strStrengthSlider = "Expression Strength";
		public string strWaveSlider = "Cycles of Orgasm(Max)";
		public string strGaugeSlider = "Ecstasy Level";
		public string strPitchSlider = "Sound Pitch";
		
		public string strCloseMenu    = "Close This Menu";

		public string strExpandUI         = "UI[▶]";
		public string strExpandAction     = "Action[▶]";
		public string strExpandConfig     = "Config[▶]";
		public string strExpandSlider1    = "❤bar[▶]";
		public string strExpandSlider2    = "Slider[▶]";
		public string strExpandSwitch     = "Switch[▶]";
		public string strExpandAddon1     = "Addon1[▶]";
		public string strExpandAddon2     = "Addon2[▶]";
		public string strExpandTest       = "Test[▶]";

		public string strExpandUIAlt       = "UI[◀]";
		public string strExpandActionAlt   = "Action[◀]";
		public string strExpandConfigAlt   = "Config[◀]";
		public string strExpandSlider1Alt  = "❤bar[◀]";
		public string strExpandSlider2Alt  = "Slider[◀]";
		public string strExpandSwitchAlt   = "Switch[◀]";
		public string strExpandAddon1Alt   = "Addon1[◀]";
		public string strExpandAddon2Alt   = "Addon2[◀]";
		public string strExpandTestAlt     = "Test[◀]";
		public string strGenderSVar  = "She";
		public string strGenderPVar = "her";
		public string strGenderOVar = "her";

		public string strExpandAlt = "[-]";
/*		
		public string strSoundOn = "Sound";
		public string strEyesControlOn = "EyesControl";
		public string strTearsOn = "Tears";
		public string strExpressionOn = "Expression";
		public string strBlushingOn = "Blushing";
*/		
		public string strStatusFieldVar;
		public string strChangeSizeVar;
		public string strSoundOnButtonVar;
		public string strEyesControlOnButtonVar;
		public string strTearsOnButtonVar;
		public string strExpressionOnButtonVar;
		public string strBlushingOnButtonVar;
		
		public string strDroolOnButtonVar;
		public string strEyesRollupOnButtonVar;
		public string strNippleErectionOnButtonVar;
		public string strClitorisErectionOnButtonVar;
		public string strHeadMotionOnButtonVar;
		public string strPeeingOnButtonVar;
		              
		public string strAutoExpressionOnButtonVar;
		public string strAutoBlinkOnButtonVar;

		public string strSoundOnButtonOn = "Sound[ON]";
		public string strEyesControlOnButtonOn = "EyesControl[ON]";
		public string strTearsOnButtonOn = "Tears[ON]";
		public string strExpressionOnButtonOn = "Expression[ON]";
		public string strBlushingOnButtonOn = "Blushing[ON]";

		public string strDroolOnButtonOn = "Drool[ON]";
		public string strEyesRollupOnButtonOn = "EyesRollup[ON]";
		public string strNippleErectionOnButtonOn = "NippleErection[ON]";
		public string strClitorisErectionOnButtonOn = "ClitorisErection[ON]";
		public string strHeadMotionOnButtonON = "HeadMotion[ON]";
		public string strPeeingOnButtonOn = "Peeing[ON]";
		              
		public string strAutoExpressionOnButtonOn = "AutoExprOFF[ON]";
		public string strAutoBlinkOnButtonOn = "AutoBlinkOFF[ON]";

		public string strSoundOnButtonOff = "Sound[  ]";
		public string strEyesControlOnButtonOff = "EyesControl[  ]";
		public string strTearsOnButtonOff = "Tears[  ]";
		public string strExpressionOnButtonOff = "Expression[  ]";
		public string strBlushingOnButtonOff = "Blushing[  ]";
		
		public string strDroolOnButtonOff = "Drool[  ]";
		public string strEyesRollupOnButtonOff = "EyesRollup[  ]";
		public string strNippleErectionOnButtonOff = "NippleErection[  ]";
		public string strClitorisErectionOnButtonOff = "ClitorisErection[  ]";
		public string strHeadMotionOnButtonOff = "HeadMotion[  ]";
		public string strPeeingOnButtonOff = "Peeing[  ]";
		              
		public string strAutoExpressionOnButtonOff = "AutoExpression[  ]";
		public string strAutoBlinkOnButtonOff = "AutoBlink[  ]";

		public string strInstantSoundLow    = "Low(0.9)";
		public string strInstantSoundMiddle = "Middle(1.0)";
		public string strInstantSoundHigh   = "High(1.2)";
		public UIDynamicButton uiInstantSoundLow;
		public UIDynamicButton uiInstantSoundMiddle;
		public UIDynamicButton uiInstantSoundHigh;

		public string strInstantStrengthLow    = "Low(0.8)";
		public string strInstantStrengthMiddle = "Middle(1.0)";
		public string strInstantStrengthHigh   = "High(1.1)";
		public UIDynamicButton uiInstantStrengthLow;
		public UIDynamicButton uiInstantStrengthMiddle;
		public UIDynamicButton uiInstantStrengthHigh;

		public string strInstantWaveLow    = "Low(5)";
		public string strInstantWaveMiddle = "Middle(10)";
		public string strInstantWaveHigh   = "High(20)";
		public string strInstantWave999    = "999";
		public UIDynamicButton uiInstantWaveLow;
		public UIDynamicButton uiInstantWaveMiddle;
		public UIDynamicButton uiInstantWaveHigh;
		public UIDynamicButton uiInstantWave999;

		public bool expandUI      = true;
		public bool expandAction  = true;
		public bool expandConfig  = true;
		public bool expandSlider1 = true;
		public bool expandSlider2 = true;
		public bool expandAddon   = true;
		public bool expandTest    = true;

		public int line = 0;
		public int lineMainLast = 0;
		
		#endregion
		
		#region common
        public WorldUI(EBATCore core, float scale = 0.002f)
        {
            this.plugin = core as MVRScript;
            this.UIScale = scale;
			this.core = core;
			this.canvasPos = new Vector3(0f, 0f, 0f);
			this.canvasRot = new Quaternion(0f, 0f, 0f, 0f);
			this.lineMainLast = 0;
        }
		
		public void loadSettings(){
			try{
				this.customUi = core.customUi;
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
			try{
				strOrgasmButtonVar = (core.isDuringOrgasm || core.isDuringAfterglow) ? strOrgasmButtonAlt : strOrgasmButton;
				strGenderSVar = (core.gender=="Male") ? "He" : "She";
				strGenderPVar = (core.gender=="Male") ? "his" : "her";
				strGenderOVar = (core.gender=="Male") ? "him" : "her";
				
				worldUIAddon1 = new WorldUIAddon1(this);
				DoWorldUIAddon2Function("Construct");
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void SetCanvasPosition(){
			canvasPos.x = customUi.jsCanvasPositionX.val;
			canvasPos.y = customUi.jsCanvasPositionY.val;
			canvasPos.z = customUi.jsCanvasPositionZ.val;
			
			canvasRot.x = customUi.jsCanvasRotationX.val;
			canvasRot.y = customUi.jsCanvasRotationY.val;
			canvasRot.z = customUi.jsCanvasRotationZ.val;
			canvasRot.w = customUi.jsCanvasRotationW.val;
		}
		
		public void OnDestroy()
		{
			RemoveMenuBody();
			worldUIAddon1.RemoveMenuBodyAddon();
			DoWorldUIAddon2Function("RemoveMenuBodyAddon");
			RemoveMenuBase();
		}
		#endregion
				
		#region Make Base UI
		public void makeWorldUI(){
			MakeMenuBase();
			if(core.launchMode == "normal"){
				ExpandMenu();
			}else if(core.launchMode == "paused"){
				//MakeMenuBody();
				strPauseMenuVar = strPauseMenuAlt;
				MakeMenuBodyPartMinAltPaused();
				//LabelSwitch();
//				OnPauseClick();
			}
		}
		
		public void MakeMenuBodyIfNeeded(){
			if(core.launchMode == "normal"){
				ExpandMenu();
			}else if(core.launchMode == "paused"){
				strPauseMenuVar = strPauseMenuAlt;
				MakeMenuBodyPartMinAltPaused();
			}
		}		

		public void RemoveMenuAll(){
			RemoveMenuBody();
		}
		
		public void RemoveMenuBase(){
			if (UIAtom != null){
				SuperController.singleton.RemoveAtom(UIAtom);
			}
			if (SuperController.singleton != null){
				SuperController.singleton.RemoveCanvas(canvas);
			}			
		}
		
		public void MakeMenuBase(){
			Vector3 headPosition = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			
			if(UIAtom == null){
				MakeCanvas();
				
				core.StartCoroutine(core.CreateAtom("Empty", "UI", (tmpatom)=>
				{
					UIAtom = tmpatom;
					Utility.LookFront(UIAtom.mainController.transform);
					UIAtom.mainController.transform.position = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
					UIAtom.mainController.transform.Translate(Vector3.left * -0.5f);
					canvas.transform.SetParent(UIAtom.mainController.transform, true);
				}));
			}
			
			if(customUi.jsCanvasPositionX.val == 0f){
				canvasPos = Utility.getPosition(canvas.transform);
			}else{
				SetCanvasPosition();
			}
		}
		
		public void MakeCanvas(){
            GameObject canvasObject = new GameObject();
            canvas = canvasObject.AddComponent<Canvas>();
            canvas.renderMode = RenderMode.WorldSpace;
            canvas.pixelPerfect = false;
            SuperController.singleton.AddCanvas(canvas);

            CanvasScaler cs = canvasObject.AddComponent<CanvasScaler>();
            cs.scaleFactor = 100.0f;
            cs.dynamicPixelsPerUnit = 1f;

            GraphicRaycaster gr = canvasObject.AddComponent<GraphicRaycaster>();

            canvas.transform.localScale = new Vector3(this.UIScale, this.UIScale, this.UIScale);
			Utility.LookFront(canvas.transform);
			
			Vector3 headPosition = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			canvas.transform.position = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			canvas.transform.Translate(Vector3.left * -0.5f);
		}
		
		public void SetExpandValue(string type){
			if(type == "Expand"){
				expandUI      = true;
				expandAction  = true;
				expandConfig  = true;
				expandSlider1 = true;
				expandSlider2 = true;
				worldUIAddon1.OnExpandCommonValueOnly("Addon1");
				DoWorldUIAddon2Function("ExpandAddon2All");
			}else if(type == "Collapse"){
				expandUI      = false;
				expandAction  = false;
				expandConfig  = false;
				expandSlider1 = false;
				expandSlider2 = false;
				worldUIAddon1.OnCollapseCommonValueOnly("Addon1");
				DoWorldUIAddon2Function("CollapseAddon2All");
			}else if(type == "BarOnly"){
				expandUI      = false;
				expandAction  = false;
				expandConfig  = false;
				expandSlider1 = true;
				expandSlider2 = false;
				worldUIAddon1.OnCollapseCommonValueOnly("Addon1");
				DoWorldUIAddon2Function("CollapseAddon2All");
			}
		}
		#endregion
		
		#region Make UI Body
		public void MakeMenuBody(){
			line = 0;
			MakeMenuBodyMain();
			lineMainLast = line;
			lineMainLast -= 2;
			worldUIAddon1.MakeMenuBodyAddon();
			DoWorldUIAddon2Function("MakeMenuBodyAddon");
			Coloring();
		}
		
		public void MakeMenuBodyMain(){
			MakeMenuBodyPartMin();
			
			if(expandSlider1){
				line++;
				MakeMenuBodyPartCollapseButton("Slider1", line);
				MakeMenuBodyPartSlider1();
			}else{
				MakeMenuBodyPartExpandButton("Slider1");
			}
			
			if(expandUI){
				MakeMenuBodyPartCollapseButton("UI", line + 1);
				MakeMenuBodyPartUI();
			}else{
				MakeMenuBodyPartExpandButton("UI");
			}
			
			if(expandAction){
				MakeMenuBodyPartCollapseButton("Action", line + 2);
				MakeMenuBodyPartAction();
			}else{
				MakeMenuBodyPartExpandButton("Action");
			}
						
			if(expandConfig){
				MakeMenuBodyPartCollapseButton("Config", line + 2);
				MakeMenuBodyPartConfig();
			}else{
				MakeMenuBodyPartExpandButton("Config");
			}
			
//			line++;
			
			if(expandSlider2){
				line++;
				int tmpLine = line + 2;
#if	(EBATWO)
				tmpLine = line + 4;
#endif	
				MakeMenuBodyPartCollapseButton("Slider2", tmpLine);
				MakeMenuBodyPartSlider2();
			}else{
				MakeMenuBodyPartExpandButton("Slider2");
			}
			LabelSwitch();
		}
		
		public void MakeMenuBodyPartExpandButton(string type){
			if(type == "UI"){
				uiExpandUI = MakeButton(strExpandUI, -1, line);
				uiExpandUI.button.onClick.AddListener(OnExpandUI);
			}else if(type == "Action"){
				uiExpandAction = MakeButton(strExpandAction, -1, line);
				uiExpandAction.button.onClick.AddListener(OnExpandAction);
			}else if(type == "Config"){
				uiExpandConfig = MakeButton(strExpandConfig, -1, line);
				uiExpandConfig.button.onClick.AddListener(OnExpandConfig);
			}else if(type == "Slider1"){
				uiExpandSlider1 = MakeButton(strExpandSlider1, -1, line);
				uiExpandSlider1.button.onClick.AddListener(OnExpandSlider1);
			}else if(type == "Slider2"){
				uiExpandSlider2 = MakeButton(strExpandSlider2, -1, line);
				uiExpandSlider2.button.onClick.AddListener(OnExpandSlider2);
			}			
			line++;
		}
		
		public void MakeMenuBodyPartCollapseButton(string type, int tmpLine){
			if(type == "UI"){
				uiExpandUI = MakeButton(strExpandUIAlt, -1, tmpLine, height:buttonSizeY2);
				uiExpandUI.button.onClick.AddListener(OnCollapseUI);
			}else if(type == "Action"){
				uiExpandAction = MakeButton(strExpandActionAlt, -1, tmpLine, height:buttonSizeY3);
				uiExpandAction.button.onClick.AddListener(OnCollapseAction);
			}else if(type == "Config"){
				uiExpandConfig = MakeButton(strExpandConfigAlt, -1, tmpLine, height:buttonSizeY3);
				uiExpandConfig.button.onClick.AddListener(OnCollapseConfig);
			}else if(type == "Slider1"){
				uiExpandSlider1 = MakeButton(strExpandSlider1Alt, -1, tmpLine, height:sliderSizeY);
				uiExpandSlider1.button.onClick.AddListener(OnCollapseSlider1);
			}else if(type == "Slider2"){
				bool isOrgasmOn = false;
#if	(EBATWO)
				isOrgasmOn = true;
#endif
				if(isOrgasmOn){
					uiExpandSlider2 = MakeButton(strExpandSlider2Alt, -1, tmpLine, height:sliderSizeY3);
				}else{
					uiExpandSlider2 = MakeButton(strExpandSlider2Alt, -1, tmpLine, height:sliderSizeY2);
				}
				uiExpandSlider2.button.onClick.AddListener(OnCollapseSlider2);
			}
		}
		
		public void MakeMenuBodyPartMin(){
			uiCorner = MakeSpacer(-1, line);
			uiMinimizeMenu = MakeButton(strMinimizeMenu, -1, line, isMinimizeButton:true);
			uiPauseMenu = MakeButton(strPauseMenuVar, 0, 0, width:20f);
			uiPauseMenu.button.onClick.AddListener(OnPauseClick);			
			line++;
			uiMinimizeMenu.button.onClick.AddListener(OnMinimizeMenuClick);	
		}

		public void MakeMenuBodyPartMinAlt(){
			uiMinimizeMenu = MakeButton(strMinimizeMenuAlt, -1, 0, isMinimizeButton:true);
			uiMinimizeMenu.button.onClick.AddListener(ExpandMenu);
			uiPauseMenu = MakeButton(strPauseMenuVar, 0, 0, width:20f);
			uiPauseMenu.button.onClick.AddListener(OnPauseClick);			
			Coloring();
			LabelSwitchPauseOnly();			
		}
		
		public void MakeMenuBodyPartMinAltPaused(){
			uiMinimizeMenu = MakeButton(strMinimizeMenuAlt, -1, 0, isMinimizeButton:true);
			uiPauseMenu = MakeButton(strPauseMenuVar, 0, 0, width:20f);
			uiPauseMenu.button.onClick.AddListener(OnPauseEndClick);
			Coloring();
			LabelSwitchPauseOnly();			
		}
		
		public void MakeMenuBodyPartUI(){
			uiChangeSize = MakeButton(strChangeSizeVar, 0, line);
			uiOpenAtomMenu = MakeButton(strOpenAtomMenu, 1, line);
			uiCloseUI = MakeButton(strCloseUI, 2, line);
			uiLookFrontUI = MakeButton(strLookFrontUI, 3, line);
			line++;
			
			uiCollapseUI = MakeButton(strCollapseUI, 0, line);
			uiExpandAllUI = MakeButton(strExpandAllUI, 1, line);
			uiCollapseWOBarUI = MakeButton(strCollapseWOBarUI, 2, line);
			uiReloadPlugins = MakeButton(strReloadPlugins, 3, line);
			uiCloseMenu = MakeButton(strCloseMenu, 4, line);
			line++;
			
			uiChangeSize.button.onClick.AddListener(OnChangeSizeClick);
			uiCloseMenu.button.onClick.AddListener(OnCloseMenuClick);
			uiOpenAtomMenu.button.onClick.AddListener(OnOpenAtomMenuClick);
			uiLookFrontUI.button.onClick.AddListener(OnLookFrontClick);
			uiCloseUI.button.onClick.AddListener(OnCloseUIClick);
			uiReloadPlugins.button.onClick.AddListener(OnReloadPluginsClick);
			uiCollapseUI.button.onClick.AddListener(OnCollapseUIClick);
			uiExpandAllUI.button.onClick.AddListener(OnExpandAllUIClick);
			uiCollapseWOBarUI.button.onClick.AddListener(OnCollapseWOBarUIClick);
		}
		
		public void MakeMenuBodyPartAction(){
			//orgasm class relatives
			string strEcstasyVar = core.orgasmModeOn ? strOrgasmButtonVar : strMaximinzeEcstasy;
			uiOrgasmButton = MakeButton(strEcstasyVar, 0, line);
			uiPeeButton = MakeButton(strPeeButton, 1, line);
			uiResetExpressionButton = MakeButton(strResetExpressionButton, 3, line);
			uiCalmDownButton = MakeButton(strCalmDownButton, 2, line);
			line++;
			uiFaceForward  = MakeButton(strFaceForward,  0, line);
			uiBackBending  = MakeButton(strBackBending,  1, line);
			uiBackBendingStrong  = MakeButton(strBackBendingStrong,  2, line);
			line++;
			uiFaceSideways = MakeButton(strFaceSideways, 0, line);
			uiFaceSidewaysAlt = MakeButton(strFaceSidewaysAlt, 1, line);
			uiFaceSidewaysMax = MakeButton(strFaceSidewaysMax, 2, line);
			uiLookGlancing = MakeButton(strLookGlancing, 3, line);
			line++;
			
			uiOrgasmButton.button.onClick.AddListener(OnOrgasmButtonClick);
			uiPeeButton.button.onClick.AddListener(OnPeeButtonClick);
			uiResetExpressionButton.button.onClick.AddListener(OnResetExpressionButton);
			uiCalmDownButton.button.onClick.AddListener(OnCalmDownButtonClick);
			uiFaceForward.button.onClick.AddListener(OnFaceForwardClick);
			uiFaceSideways.button.onClick.AddListener(OnFaceSidewaysClick);
			uiFaceSidewaysAlt.button.onClick.AddListener(OnFaceSidewaysAltClick);
			uiFaceSidewaysMax.button.onClick.AddListener(OnFaceSidewaysMaxClick);
			uiLookGlancing.button.onClick.AddListener(OnLookGlancingClick);
			uiBackBending.button.onClick.AddListener(OnBackBendingWeakClick);
			uiBackBendingStrong.button.onClick.AddListener(OnBackBendingStrongClick);
		}

		public void MakeMenuBodyPartConfig(){
			uiExpressionOnButton       = MakeButton(strExpressionOnButtonVar, 0, line);
			uiBlushingOnButton         = MakeButton(strBlushingOnButtonVar, 1, line);
			uiTearsOnButton            = MakeButton(strTearsOnButtonVar, 2, line);
			uiDroolOnButton            = MakeButton(strDroolOnButtonVar, 3, line);			
			line++;
			uiAutoExpressionOnButton   = MakeButton(strAutoExpressionOnButtonVar, 0, line);	
			uiAutoBlinkOnButton        = MakeButton(strAutoBlinkOnButtonVar, 1, line);		
			uiEyesControlOnButton      = MakeButton(strEyesControlOnButtonVar, 2, line);
			uiEyesRollupOnButton       = MakeButton(strEyesRollupOnButtonVar, 3, line);		
			line++;
			uiSoundOnButton            = MakeButton(strSoundOnButtonVar, 0, line);
			uiPeeingOnButton           = MakeButton(strPeeingOnButtonVar, 1, line);			
			uiNippleErectionOnButton   = MakeButton(strNippleErectionOnButtonVar, 2, line);	
			uiClitorisErectionOnButton = MakeButton(strClitorisErectionOnButtonVar, 3, line);
			uiHeadMotionOnButton       = MakeButton(strHeadMotionOnButtonVar, 4, line);
			line++;
			
			uiExpressionOnButton.button.onClick.AddListener(OnExpressionOnButtonClick);
			uiBlushingOnButton.button.onClick.AddListener(OnBlushingOnButtonClick);
			uiTearsOnButton.button.onClick.AddListener(OnTearsOnButtonClick);
			uiDroolOnButton.button.onClick.AddListener(OnDroolOnButtonClick);			

			uiAutoExpressionOnButton.button.onClick.AddListener(OnAutoExpressionOnButtonClick);
			uiAutoBlinkOnButton.button.onClick.AddListener(OnAutoBlinkOnButtonClick);
			uiEyesControlOnButton.button.onClick.AddListener(OnEyesControlOnButtonClick);
			uiEyesRollupOnButton.button.onClick.AddListener(OnEyesRollupOnButtonClick);
			
			uiSoundOnButton.button.onClick.AddListener(OnSoundOnButtonClick);
			uiPeeingOnButton.button.onClick.AddListener(OnPeeingOnButtonClick);		
			uiNippleErectionOnButton.button.onClick.AddListener(OnNippleErectionOnButtonClick);
			uiClitorisErectionOnButton.button.onClick.AddListener(OnClitorisErectionOnButtonClick);			
			uiHeadMotionOnButton.button.onClick.AddListener(OnHeadMotionOnButtonClick);			
		}
		
		public void MakeMenuBodyPartSlider1(){
			uiGaugeSlider = MakeSlider(strGaugeSlider, 0, line, 0f, 120f, (float)core.getGauge());				
			Image bgImage = uiGaugeSlider.GetComponentInChildren<Image>();
			bgImage.color = new Color(1f, 0.25f, 0.75f);
			uiGaugeSlider.labelText.color = new Color(1, 0, 0);
			
			uiStatusField = MakeTextField(strStatusField, quick1, line, width:buttonSizeX3, height:sliderSizeY);
			line+= 1;
		}
		
		public void MakeMenuBodyPartSlider2(){
#if	(EBATWO)	
			uiWaveSlider = MakeSlider(strWaveSlider, 0, line, 0f, 1000f, core.orgasm.orgasmWaveCycleBigMax);
			uiWaveSlider.slider.onValueChanged.AddListener(OnWaveSliderChange);
			uiInstantWaveLow    = MakeButton(strInstantWaveLow,    quick1, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantWaveMiddle = MakeButton(strInstantWaveMiddle, quick2, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantWaveHigh   = MakeButton(strInstantWaveHigh,   quick3, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantWave999    = MakeButton(strInstantWave999,    quick4, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantWaveLow.button.onClick.AddListener(   OnInstantWaveLowClick);
			uiInstantWaveMiddle.button.onClick.AddListener(OnInstantWaveMiddleClick);
			uiInstantWaveHigh.button.onClick.AddListener(  OnInstantWaveHighClick);
			uiInstantWave999.button.onClick.AddListener(   OnInstantWave999Click);
			line += 2;
#endif
			uiPitchSlider = MakeSlider(strPitchSlider, 0, line, 0.8f, 1.5f, core.sound.headAudioSource.pitch);
			uiPitchSlider.slider.onValueChanged.AddListener(OnPitchSliderChange);
			uiInstantSoundLow    = MakeButton(strInstantSoundLow,   quick1, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantSoundMiddle = MakeButton(strInstantSoundMiddle,quick2, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantSoundHigh   = MakeButton(strInstantSoundHigh,  quick3, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantSoundLow.button.onClick.AddListener(   OnInstantSoundLowClick);
			uiInstantSoundMiddle.button.onClick.AddListener(OnInstantSoundMiddleClick);
			uiInstantSoundHigh.button.onClick.AddListener(  OnInstantSoundHighClick);
			line += 2;
			
			uiStrengthSlider = MakeSlider(strStrengthSlider, 0, line, 0f, 1.5f, core.expression2.fmm.baseMultiplier);
			uiStrengthSlider.slider.onValueChanged.AddListener(OnStrengthSliderChange);
			uiInstantStrengthLow    = MakeButton(strInstantStrengthLow,    quick1, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantStrengthMiddle = MakeButton(strInstantStrengthMiddle, quick2, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantStrengthHigh   = MakeButton(strInstantStrengthHigh,   quick3, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantStrengthLow.button.onClick.AddListener(   OnInstantStrengthLowClick);
			uiInstantStrengthMiddle.button.onClick.AddListener(OnInstantStrengthMiddleClick);
			uiInstantStrengthHigh.button.onClick.AddListener(  OnInstantStrengthHighClick);
			line += 1;
		}
		
		public void RemoveMenuBody(){
			RemoveMenuBodyMain();
			worldUIAddon1.RemoveMenuBodyAddon();
			DoWorldUIAddon2Function("RemoveMenuBodyAddon");
		}

		public void ColoringButton(UIDynamicButton[] buttons, float fR, float fG, float fB){
			foreach(UIDynamicButton button in buttons){
				if(button != null){
					button.buttonColor = new Color(fR, fG, fB);	
				}
			}
		}
		
		public void ColoringTextField(UIDynamicTextField[] texts, float fR, float fG, float fB){
			foreach(UIDynamicTextField text in texts){
				if(text != null){
					text.backgroundColor = new Color(fR, fG, fB);	
				}
			}
		}
		
		public void Coloring(){
			try{
				UIDynamicButton[] baseButtons = {
					uiMinimizeMenu,
				};
				
				foreach(UIDynamicButton button in baseButtons){
					if(button != null){
						if(core.launchMode == "normal"){
							button.buttonColor = new Color(52f/255f, 164f/255f, 235f/255f);				
						}else if(core.launchMode == "paused"){
							button.buttonColor = new Color(128f/255f, 128f/255f, 128f/255f);				
						}
					}
				}
				
				UIDynamicButton[] buttons = {
					uiExpressionOnButton, uiBlushingOnButton, uiTearsOnButton, uiDroolOnButton,
					uiAutoExpressionOnButton, uiAutoBlinkOnButton, uiEyesControlOnButton, uiEyesRollupOnButton, 
					uiSoundOnButton, uiPeeingOnButton, uiNippleErectionOnButton, uiClitorisErectionOnButton, uiHeadMotionOnButton,
					uiInstantSoundLow,   uiInstantStrengthLow,   uiInstantWaveLow,   
					uiInstantSoundMiddle,uiInstantStrengthMiddle,uiInstantWaveMiddle,
					uiInstantSoundHigh,  uiInstantStrengthHigh,  uiInstantWaveHigh,  uiInstantWave999,
				};				
				ColoringButton(buttons, 198f/255f, 250f/255f, 192f/255f);

				UIDynamicSlider[] otherSliders = {
					uiStrengthSlider, uiPitchSlider,
#if (EBATWO)
					uiWaveSlider,
#endif
				};
				
				foreach(UIDynamicSlider slider in otherSliders){
					if(slider != null){
						Image bgImage = slider.GetComponentInChildren<Image>();
						bgImage.color = new Color(198f/255f, 250f/255f, 192f/255f);
					}
				}
				
				UIDynamicButton[] expandButtons = {
					uiExpandUI, uiExpandAction, uiExpandConfig, uiExpandSlider1, uiExpandSlider2, 
					worldUIAddon1.uiExpandAddon1,    
#if	(ADDON2)	
					worldUIAddon2.uiExpandAddon2, worldUIAddon2.uiExpandAddon2New, worldUIAddon2.uiExpandTest
#endif
				};
				ColoringButton(expandButtons, 235f/255f, 161f/255f, 52f/255f);

				UIDynamicTextField[] texts = {
					uiStatusField,
				};
				ColoringTextField(texts, 224f/255f, 192f/255f, 255f/255f);
				
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void RemoveMenuBodyMain(){
			UIDynamicButton[] buttons = {
				uiMinimizeMenu, uiCloseMenu, uiOpenAtomMenu, uiCloseUI, uiChangeSize, uiLookFrontUI, 
				uiReloadPlugins, uiCollapseUI, uiCollapseWOBarUI, uiExpandAllUI,
				uiResetExpressionButton, uiCalmDownButton, uiOrgasmButton, uiPeeButton, 
				uiFaceForward, uiFaceSideways, uiFaceSidewaysAlt, uiFaceSidewaysMax, 
				uiLookGlancing, uiBackBending, uiBackBendingStrong, 
				uiExpressionOnButton, uiBlushingOnButton, uiTearsOnButton, uiDroolOnButton,
				uiAutoExpressionOnButton, uiAutoBlinkOnButton, uiEyesControlOnButton, uiEyesRollupOnButton, 
				uiSoundOnButton, uiPeeingOnButton, uiNippleErectionOnButton, uiClitorisErectionOnButton, uiHeadMotionOnButton,
				uiExpandUI, uiExpandAction, uiExpandConfig, uiExpandSlider1, uiExpandSlider2, uiPauseMenu,
				uiInstantSoundLow,   uiInstantStrengthLow,   uiInstantWaveLow,   
				uiInstantSoundMiddle,uiInstantStrengthMiddle,uiInstantWaveMiddle,
				uiInstantSoundHigh,  uiInstantStrengthHigh,  uiInstantWaveHigh,  uiInstantWave999,
			};

			UIDynamicSlider[] sliders = {
				uiStrengthSlider, uiWaveSlider, uiGaugeSlider, uiPitchSlider,
			};

			UIDynamicTextField[] texts = {
				uiStatusField,
			};
			
			RemoveMenuBodyImpl(buttons, sliders, texts);
		}

		public void RemoveMenuBodyImpl(UIDynamicButton[] buttons, UIDynamicSlider[] sliders, UIDynamicTextField[] texts = null){
			foreach(UIDynamicButton button in buttons){
				if(button != null){ plugin.RemoveButton(button);} 
			}
			
			foreach(UIDynamicSlider slider in sliders){
				if(slider != null){ Utility.RemoveSliderForCanvas(slider);}
			}			
			
			if(texts == null){ return; }
			
			foreach(UIDynamicTextField text in texts){
//				if(text != null){ plugin.RemoveTextField(text);}
				if(text != null){ Utility.RemoveTextFieldForCanvas(text);}
			}
		}
		#endregion
		
		#region Define UI Function Main
		public void OnExpandCommon(string type){
			if(type == "UI"){
				expandUI = expandUI ? false : true;
			}else if(type == "Action"){
				expandAction = expandAction ? false : true;
			}else if(type == "Config"){
				expandConfig = expandConfig ? false : true;
			}else if(type == "Slider1"){
				expandSlider1 = expandSlider1 ? false : true;
			}else if(type == "Slider2"){
				expandSlider2 = expandSlider2 ? false : true;
			}
			RemoveMenuBody();
			MakeMenuBody();
		}
		
		public void OnExpandUI(){OnExpandCommon("UI");}
		public void OnExpandAction(){OnExpandCommon("Action");}
		public void OnExpandConfig(){OnExpandCommon("Config");}
		public void OnExpandSlider1(){OnExpandCommon("Slider1");}
		public void OnExpandSlider2(){OnExpandCommon("Slider2");}
		
		public void OnCollapseUI(){OnExpandCommon("UI");}
		public void OnCollapseAction(){OnExpandCommon("Action");}
		public void OnCollapseConfig(){OnExpandCommon("Config");}
		public void OnCollapseSlider1(){OnExpandCommon("Slider1");}
		public void OnCollapseSlider2(){OnExpandCommon("Slider2");}
		
		public void OnOrgasmButtonClick(){
			if(core.orgasmModeOn == false){
				if(core.getGauge() < core.stageThreshold[5]){
					core.setGauge(core.stageThreshold[5]);
					core.OnErogenousZoneTouch("DeeperVagina");
					core.updateAll();
				}
			}else{
#if	(EBATWO)
				if(uiOrgasmButton.label == strOrgasmButton){
					if(core.getGauge() < core.stageThreshold[5]){
						core.setGauge(core.stageThreshold[5]);
						core.OnErogenousZoneTouch("DeeperVagina");
						core.updateAll();
					}
//					core.orgasmFunctions("orgasmStart", 0f);					
				}else{
					core.setGauge(core.stageThreshold[0]);
					core.orgasmFunctions("orgasmFinish", 0f);						
				}
#endif				
			}
		}

#if	(EBATWO)
		public void OnWaveSliderChange(float value){
			try{
				core.orgasm.orgasmWaveCycleBigMax = (int)value;
				if(core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider != null){
					core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider.value = value;
				}
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void OnInstantWaveLowClick(){
			OnInstantWaveClickCommon(5f);
		}

		public void OnInstantWaveMiddleClick(){
			OnInstantWaveClickCommon(10f);
		}

		public void OnInstantWaveHighClick(){
			OnInstantWaveClickCommon(20f);
		}

		public void OnInstantWave999Click(){
			OnInstantWaveClickCommon(999f);
		}

		public void OnInstantWaveClickCommon(float value){
			core.orgasm.orgasmWaveCycleBigMax = (int)value;
			uiWaveSlider.slider.value = (int)value;
		}		
#endif

		public void OnInstantSoundLowClick(){
			OnInstantSoundClickCommon(0.95f);
		}

		public void OnInstantSoundMiddleClick(){
			OnInstantSoundClickCommon(1.0f);
		}

		public void OnInstantSoundHighClick(){
			OnInstantSoundClickCommon(1.2f);
		}

		public void OnInstantSoundClickCommon(float value){
			core.sound.headAudioSource.pitch = value;
			uiPitchSlider.sliderControl.setSliderToValue(value);
		}
		
		public void OnInstantStrengthLowClick(){
			OnInstantStrengthClickCommon(0.8f);
		}

		public void OnInstantStrengthMiddleClick(){
			OnInstantStrengthClickCommon(1.0f);
		}

		public void OnInstantStrengthHighClick(){
			OnInstantStrengthClickCommon(1.1f);
		}

		public void OnInstantStrengthClickCommon(float value){
			core.expression2.fmm.baseMultiplier = value;
			uiStrengthSlider.slider.value = value;
		}
		
		public void OnCloseMenuClick(){
			core.customUi.dJSToggle["Display UI Menu"].SetVal(false);
			RemoveMenuBody();
		}

		public void OnMinimizeMenuClick(){
			canvasPos = Utility.getPosition(UIAtom.mainController.transform.position);
			RemoveMenuBody();
			MakeMenuBodyPartMinAlt();
		}

		public void OnPauseClick(){
			core.launchMode = "paused";
			canvasPos = Utility.getPosition(UIAtom.mainController.transform.position);
			RemoveMenuBody();
			MakeMenuBodyPartMinAltPaused();
		}
		
		public void OnPauseEndClick(){
			core.launchMode = "normal";
			plugin.RemoveButton(uiMinimizeMenu);
			plugin.RemoveButton(uiPauseMenu);
			MakeMenuBodyPartMinAlt();
		}
		
		public void ExpandMenu(){
			plugin.RemoveButton(uiMinimizeMenu);
			plugin.RemoveButton(uiPauseMenu);
			MakeMenuBody();
			LabelSwitch();
		}
		
		public void ReloadMenu(){
			RemoveMenuBody();
			MakeMenuBodyIfNeeded();
		}

		public void OnCollapseUIClick(){
			SetExpandValue("Collapse");
			ReloadMenu();
		}

		public void OnExpandAllUIClick(){
			SetExpandValue("Expand");
			ReloadMenu();
		}

		public void OnCollapseWOBarUIClick(){
			SetExpandValue("BarOnly");
			ReloadMenu();
		}

		public void OnOpenAtomMenuClick(){
			Utility.OpenAtomUI(core.atom);
		}
		
		public void OnCloseUIClick(){
			Utility.CloseUI();
		}
		
		public void OnLookFrontClick(){
			Utility.LookFront(canvas.transform);
		}

		public void OnReloadPluginsClick(){
			try{
				Utility.ReloadPlugins(core.atom);
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnChangeSizeClick(){
			if(uiChangeSize.label == strChangeSize){
				isSmall = true;
				strChangeSizeVar = strChangeSizeAlt;
				uiChangeSize.label = strChangeSizeVar;
			}else{
				isSmall = false;
				strChangeSizeVar = strChangeSize;
				uiChangeSize.label = strChangeSizeVar;				
			}
			RemoveMenuBody();
			MakeMenuBody();
		}
		
		public void OnPeeButtonClick(){
			if(core.unityAssets.peeingOnGlobal){
				if(core.getGauge() < core.stageThreshold[2]){
					core.setGauge(core.stageThreshold[2]);
					core.OnErogenousZoneTouch("DeeperVagina");						
				}
				core.unityAssets.peeRandom(core.getTime(), true);
			}
			
			DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			var ui = character.selectedCharacter.transform;			
		}

		public void OnResetExpressionButton(){
			core.expression2.resetExpression();
		}

		public void OnFaceForwardClick(){
			core.headController.FaceForwardForce(bForce:true);
		}

		public void OnFaceSidewaysClick(){
			core.headController.faceSidewaysForce(bForce:true);
		}

		public void OnFaceSidewaysAltClick(){
			core.headController.faceSidewaysAltForce(bForce:true);
		}

		public void OnFaceSidewaysMaxClick(){
			core.headController.faceSidewaysMaxForce(bForce:true);
		}

		public void OnLookGlancingClick(){
			core.headController.glanceForce(bForce:true);
		}

		public void OnBackBendingWeakClick(){
			core.headController.bendHerselfBackForce(bForce:true);
		}

		public void OnBackBendingStrongClick(){
			core.headController.bendHerselfBackStrongForce(bForce:true);
		}

		public void OnCalmDownButtonClick(){
			core.orgasmFunctions("orgasmFinish", 0f);
			core.setGauge(0);
			core.orgasmCount = 0;
			core.hasMultipleOrgasms = false;
			core.tears.refreshTears();
			core.blushing.switchFaceDecal("");
			core.expression2.resetExpression();			
		}
		
		public void UpdateStatus(){
			if(uiStatusField == null){ return; };
			
			string status = strGenderSVar + " is not sexually aroused at all.";
			string th = "th";
			if(core.curStage == 1){
				th = "st";
			}else if(core.curStage == 2){
				th = "nd";
			}else if(core.curStage == 3){
				th = "rd";
			}
			if(core.curStage >= 1){
				status = strGenderSVar + " is on the " + core.curStage + th + " level of arousal. ";
			}
			if(!core.isHot){
				status += strGenderSVar + " is calm.";
			}else{
				if(core.isDuringAfterglow){
					status += strGenderSVar + " is having a lingering orgasm. ";
				}else if(core.isDuringOrgasm){
					if(core.hasMultipleOrgasms){
						status += strGenderSVar + " is having multiple orgasms. ";
					}else{
						status += strGenderSVar + " is having an orgasm. ";
					}
				}else{
					status += strGenderSVar + " is sexually aroused. ";
				}
				if(core.orgasmCount == 0){
				}else if(core.orgasmCount == 1){
					status += strGenderSVar + " has already reached " + strGenderPVar + " climax. ";
				}else{
					status += strGenderSVar + " had already climaxed " + core.orgasmCount + " times. ";
				}
			}
			if(core.unityAssets.isPeeFree == false){
				status += strGenderSVar + " has squirted. ";
			}
			
			uiStatusField.text = status;
		}
		
		public void LabelSwitchPauseOnly(){
			LabelVarChangePauseOnly();
			LabelUpdatePauseOnly();
		}
		
		public void LabelVarChangePauseOnly(){
			strPauseMenuVar = core.launchMode == "paused" ? strPauseMenuAlt : strPauseMenu;
		}
		
		public void LabelUpdatePauseOnly(){
			uiPauseMenu.label			    = strPauseMenuVar;			
		}
		
		public void LabelSwitch(){
			LabelVarChange();
			LabelUpdate();
		}
				
		public void LabelVarChange(){
			strPauseMenuVar = core.launchMode == "paused" ? strPauseMenuAlt : strPauseMenu;
			strChangeSizeVar = isSmall ? strChangeSizeAlt : strChangeSize;
			strSoundOnButtonVar = (core.sound.soundOnGlobal) ? strSoundOnButtonOn : strSoundOnButtonOff;
			strTearsOnButtonVar = (core.tears.tearsOnGlobal) ? strTearsOnButtonOn : strTearsOnButtonOff;
			strEyesControlOnButtonVar = (core.eyesControl.eyecontrolOnGlobal) ? strEyesControlOnButtonOn : strEyesControlOnButtonOff;
			strExpressionOnButtonVar = (core.expression2.expressionOnGlobal) ? strExpressionOnButtonOn : strExpressionOnButtonOff;
			strBlushingOnButtonVar = (core.blushing.blushOnGlobal) ? strBlushingOnButtonOn : strBlushingOnButtonOff;
						
			strDroolOnButtonVar = (core.tears.droolOnGlobal) ? strDroolOnButtonOn : strDroolOnButtonOff;
			strEyesRollupOnButtonVar = (core.eyesControl.eyecontrolRollupOnGlobal) ? strEyesRollupOnButtonOn : strEyesRollupOnButtonOff;
			strNippleErectionOnButtonVar = (core.bodyMorph.nippleErectionOnGlobal) ? strNippleErectionOnButtonOn : strNippleErectionOnButtonOff;
			strClitorisErectionOnButtonVar = (core.bodyMorph.clitorisErectionOnGlobal) ? strClitorisErectionOnButtonOn : strClitorisErectionOnButtonOff;
			strHeadMotionOnButtonVar = (core.headController.headMotionOnGlobal) ? strHeadMotionOnButtonON : strHeadMotionOnButtonOff;
			strPeeingOnButtonVar = (core.unityAssets.peeingOnGlobal) ? strPeeingOnButtonOn : strPeeingOnButtonOff;
						
			strAutoExpressionOnButtonVar = (core.etc.autoExpressionOffGlobal) ? strAutoExpressionOnButtonOn : strAutoExpressionOnButtonOff;
			strAutoBlinkOnButtonVar = (core.etc.autoBlinkOffGlobal) ? strAutoBlinkOnButtonOn : strAutoBlinkOnButtonOff;
		}
		
		public void LabelUpdate(){
			uiChangeSize.label              = strChangeSizeVar;
			uiSoundOnButton.label			= strSoundOnButtonVar;
			uiTearsOnButton.label			= strTearsOnButtonVar;
			uiEyesControlOnButton.label		= strEyesControlOnButtonVar;
			uiExpressionOnButton.label		= strExpressionOnButtonVar;
			uiBlushingOnButton.label		= strBlushingOnButtonVar;
			uiDroolOnButton.label			= strDroolOnButtonVar;
			uiEyesRollupOnButton.label		= strEyesRollupOnButtonVar;
			uiNippleErectionOnButton.label	= strNippleErectionOnButtonVar;
			uiClitorisErectionOnButton.label= strClitorisErectionOnButtonVar;
			uiHeadMotionOnButton.label      = strHeadMotionOnButtonVar;
			uiPeeingOnButton.label			= strPeeingOnButtonVar;
			uiAutoExpressionOnButton.label	= strAutoExpressionOnButtonVar;
			uiAutoBlinkOnButton.label		= strAutoBlinkOnButtonVar;
			uiPauseMenu.label			    = strPauseMenuVar;
//			core.debug("uiStrengthSlider.sliderValueTextFromFloat.UIText:" + uiStrengthSlider.sliderValueTextFromFloat.UIText);
		}
		
		public void OnSoundOnButtonClick(){
			core.customUi.ToggleAny("Sound On");
			LabelSwitch();
		}
		
		public void OnTearsOnButtonClick(){
			core.customUi.ToggleAny("Tears On");
			LabelSwitch();
		}
		
		public void OnExpressionOnButtonClick(){
			core.customUi.ToggleAny("Expression On");
			LabelSwitch();
		}
		
		public void OnBlushingOnButtonClick(){
			core.customUi.ToggleAny("Blush On");
			LabelSwitch();
		}
		
		public void OnEyesControlOnButtonClick(){
			core.customUi.ToggleAny("Eyes Control On");
			LabelSwitch();
		}
		
		public void OnDroolOnButtonClick(){
			core.customUi.ToggleAny("Drool On");
			LabelSwitch();
		}
		
		public void OnEyesRollupOnButtonClick(){
			core.customUi.ToggleAny("Eyes Rollup On");
			LabelSwitch();
		}
		
		public void OnNippleErectionOnButtonClick(){
			core.customUi.ToggleAny("Nipple Erection On");
			LabelSwitch();
		}
		
		public void OnClitorisErectionOnButtonClick(){
			core.customUi.ToggleAny("Clitoris Erection On");
			LabelSwitch();
		}
		
		public void OnHeadMotionOnButtonClick(){
			core.customUi.ToggleAny("Head Motion On");
			LabelSwitch();
		}
		
		public void OnPeeingOnButtonClick(){
			try{
			core.customUi.ToggleAny("Peeing On");
			LabelSwitch();
				
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void OnAutoExpressionOnButtonClick(){
			core.customUi.ToggleAny("Auto Expression Off");
			LabelSwitch();
		}
		
		public void OnAutoBlinkOnButtonClick(){
			core.customUi.ToggleAny("Auto Blink Off");
			LabelSwitch();
		}
				
		public void OnStrengthSliderChange(float value){
			try{
				core.expression2.fmm.baseMultiplier = value;
				if(core.customUi.dJSSlider["Expression Strength"].slider != null){
					core.customUi.dJSSlider["Expression Strength"].slider.value = value;
				}
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnPitchSliderChange(float value){
			try{
				core.sound.headAudioSource.pitch = value;
				if(core.customUi.dJSSlider["Sound Pitch"].slider != null){
					core.customUi.dJSSlider["Sound Pitch"].slider.value = value;
				}
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnOrgasmStart()
		{
			if(core.orgasmModeOn){
				strOrgasmButtonVar = strOrgasmButtonAlt;
				uiOrgasmButton.label = strOrgasmButtonVar;
			}
		}
		
		public void OnOrgasmStop()
		{
			if(core.orgasmModeOn){
				strOrgasmButtonVar = strOrgasmButton;
				uiOrgasmButton.label = strOrgasmButtonVar;
			}
		}
		#endregion
		
		#region Define Alias
		public float getWidth(string type, float width, bool isHeader = false){
			float size = buttonSizeX;
			if(type == "button"){
				size    = buttonSizeX;
			}else if(type == "buttonAlt"){
				size    = buttonSizeMinimizeX;
			}else if(type == "spacer"){
				size    = spacerSizeX;
				return size * (isSmall ? smallRatio * smallRatioForSize : 1.0f);				
			}else if(type == "toggle"){
				size    = toggleSizeX;
			}else if(type == "slider"){
				size    = sliderSizeX;
			}
			if(isHeader && type != "buttonAlt"){
				size = headerX;
			}
			
			if(width != 0f){
				return width * (isSmall ? smallRatio * smallRatioForSize : 1.0f);
			}else{
				return size * (isSmall ? smallRatio * smallRatioForSize : 1.0f);
			}
		}
		
		public float getHeight(string type, float height){
			float size = buttonSizeY;
			if(type == "button"){
				size    = buttonSizeY;
			}else if(type == "buttonAlt"){
				size    = buttonSizeY;
			}else if(type == "spacer"){
				size    = spacerSizeY;
			}else if(type == "toggle"){
				size    = toggleSizeY;
			}else if(type == "slider"){
				size    = sliderSizeY;
			}
			if(height != 0f){
				return height * (isSmall ? smallRatio : 1.0f);
			}else{
				return size * (isSmall ? smallRatio : 1.0f);
			}
		}
		
		public float getXPos(int x, bool isMinimizeButton = false){
			return getXPos((float)x, isMinimizeButton);
		}
		
		public float getXPos(float x, bool isMinimizeButton = false){
			if(isMinimizeButton){
				return xOffsetMinimize * (isSmall ? smallRatio : 1.0f);
			}else if(x == -1){
				return xOffset * (isSmall ? smallRatio : 1.0f);
			}else{
				return xIndent + (xOffset + xSpacing * x) * (isSmall ? smallRatio : 1.0f);
			}			
		}
		
		public float getYPos(int y){
			return (yOffset + ySpacing * y) * (isSmall ? smallRatio : 1.0f);
		}
		
		public int getFontSize(){
			return isSmall ? fontSizeAlt : fontSize;
		}
		
		public UIDynamic MakeSpacer(int x, int y, float width = 0f, float height = 0f){
			width = getWidth("spacer", width, x == -1);
			height = getHeight("spacer", height);
			float xpos = getXPos(x);
			float ypos = getYPos(y);
			
			UIDynamic uiSpacer = Utility.CreateSpacer(plugin, canvas, width, height);
			Utility.TranslateUI(uiSpacer, xpos, ypos);
			return uiSpacer;
		}
		
		public UIDynamicButton MakeButton(string name, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false){
			int fontSizeVar = getFontSize();
			string type = isMinimizeButton ? "buttonAlt" : "button";
			width = getWidth(type, width, x == -1);
			height = getHeight(type, height);				
			float xpos = getXPos(x, isMinimizeButton);
			float ypos = getYPos(y);
			
			UIDynamicButton uiButton = Utility.CreateButton(plugin, canvas, name, width, height, fontSizeVar);
			Utility.TranslateUI(uiButton, xpos, ypos);
			return uiButton;
		}
		
		public UIDynamicTextField MakeTextField(string text, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false){
			int fontSizeVar = getFontSize();
			string type = isMinimizeButton ? "buttonAlt" : "button";
			width = getWidth(type, width, x == -1);
			height = getHeight(type, height);				
			float xpos = getXPos(x, isMinimizeButton);
			float ypos = getYPos(y);
			
			UIDynamicTextField uiText = Utility.CreateTextField(plugin, canvas, text, width, height, fontSizeVar);
			Utility.TranslateUI(uiText, xpos, ypos);
			return uiText;
		}
		
		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false){
			return MakeButton(name, (float)x, y, width, height, isMinimizeButton);
		}
		
		public UIDynamicButton MakeButtonForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			return MakeButton(name, x, y, width, height);
		}		
		
		public UIDynamicTextField MakeTextFieldForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			return MakeTextField(name, x, y, width, height);
		}		
		
		public UIDynamicToggle MakeToggle(string name, int x, int y, float width = 0f, float height = 0f){
			try{
			int fontSizeVar = getFontSize();
			width = getWidth("toggle", width, x == -1);
			height = getHeight("toggle", height);
			float xpos = getXPos(x);
			float ypos = getYPos(y);
			
			UIDynamicToggle uiToggle = Utility.CreateToggle(plugin, canvas, name, width, height, fontSizeVar);
			Utility.TranslateUI(uiToggle, xpos, ypos);
			return uiToggle;
				
			}catch(Exception e){
				core.loggerE(e);
				return null;
			}
		}
		
		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			int fontSizeVar = getFontSize();
			float width = getWidth("slider", 0, x == -1);
			float height = getHeight("slider", 0);
			float xpos = getXPos(x);
			float ypos = getYPos(y);
			
			UIDynamicSlider uiSlider = Utility.CreateSliderAlt(plugin, canvas, name, width, height, min, max, current, true, fontSizeVar, isSmall ? smallRatio : 1.0f);
			Utility.TranslateUI(uiSlider, xpos, ypos);
			return uiSlider;
		}
		
		public void DoWorldUIAddon2Function(string func){
#if	(ADDON2)
			if(func == "Construct"){
				this.worldUIAddon2 = new WorldUIAddon2(this);
			}else if(func == "RemoveMenuBodyAddon"){
				worldUIAddon2.RemoveMenuBodyAddon();
			}else if(func == "MakeMenuBodyAddon"){
				worldUIAddon2.MakeMenuBodyAddon();				
			}else if(func == "ExpandAddon2All"){
				if(worldUIAddon2.expandAddon2NewEnabled){
					worldUIAddon2.OnExpandAddon2NewValueOnly();		
					worldUIAddon2.OnExpandTestValueOnly();							
				}else{
					worldUIAddon2.OnExpandAddon2ValueOnly();		
					worldUIAddon2.OnExpandTestValueOnly();												
				}
			}else if(func == "CollapseAddon2All"){
				if(worldUIAddon2.expandAddon2NewEnabled){
					worldUIAddon2.OnCollapseAddon2NewValueOnly();		
					worldUIAddon2.OnCollapseTestValueOnly();		
				}else{
					worldUIAddon2.OnCollapseAddon2ValueOnly();		
					worldUIAddon2.OnCollapseTestValueOnly();							
				}
			}else{
				core.debug("In WorldUI: Unknown command: " + func);
			}
#endif			
		}
		#endregion
	}
}
